﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace DL880WinCE
{
    public static class RWDev
    {
        [DllImport("DL880.dll")]
        public static extern int ModulePowerOn();

        [DllImport("DL880.dll")]
        public static extern int ModulePowerOff();

        [DllImport("DL880.dll")]
        public static extern int ConnectReader(ref byte address,byte fbaud,byte COM_TYPE);

        [DllImport("DL880.dll")]
        public static extern int DisConnectReader();

        [DllImport("DL880.dll")]
        public static extern int Inventory_G2(ref byte address, 
                                              byte QValue,
                                              byte Session,
                                              byte MaskMem,
                                              byte[] MaskAdr,
                                              byte MaskLen,
                                              byte[] MaskData,
                                              byte MaskFlag,
                                              byte AdrTID,
                                              byte LenTID,
                                              byte TIDFlag,
                                              byte Target,
                                              byte InAnt,
                                              byte Scantime,
                                              byte FastFlag,
                                              byte[] EPCAndID,
                                              ref byte Ant,
                                              ref int Totallen,
                                              ref int CardNum);

        [DllImport("DL880.dll")]
        public static extern int GetReaderInformation(ref byte address,				
                                                byte[] VersionInfo,		
                                                ref byte ReaderType,				
                                                ref byte TrType,		
                                                ref byte dmaxfre,           
                                                ref byte dminfre,          
                                                ref byte powerdBm,            
                                                ref byte ScanTime,
                                                ref byte Ant,
                                                ref byte BeepEn,          
                                                ref byte OutputRep,            
                                                ref byte CheckAnt);
    
        [DllImport("DL880.dll")]
        public static extern int ReadData_G2(ref byte address,	        
                                                byte[] EPC,   
                                                byte ENum,
                                                byte Mem,             
                                                byte WordPtr,
                                                byte Num,
                                                byte[] Password,
                                                byte MaskMem,
                                                byte[] MaskAdr,
                                                byte MaskLen,
                                                byte[] MaskData,
                                                byte[] Data,
                                                ref int Errorcode);

        [DllImport("DL880.dll")]
        public static extern int WriteData_G2(ref byte address,
									byte[] EPC,
                                    byte WNum,
                                    byte ENum, 
									byte Mem,
									byte WordPtr,
									byte[]Writedata,
									byte[] Password,
                                    byte MaskMem,
                                    byte[] MaskAdr,
                                    byte MaskLen,
                                    byte[] MaskData,
									ref int Errorcode);

        [DllImport("DL880.dll")]
        public static extern int BlockWrite_G2(ref byte address,
                                    byte[] EPC,
                                    byte WNum,
                                    byte ENum,
                                    byte Mem,
                                    byte WordPtr,
                                    byte[] Writedata,
                                    byte[] Password,
                                    byte MaskMem,
                                    byte[] MaskAdr,
                                    byte MaskLen,
                                    byte[] MaskData,
                                    ref int Errorcode);

        [DllImport("DL880.dll")]
        public static extern int SetRfPower(ref byte address,
                                     byte PowerDbm);

        [DllImport("DL880.dll")]
        public static extern int SetInventoryScanTime(ref byte address,
                                     byte ScanTime);


        [DllImport("DL880.dll")]
        public static extern int SetRegion(ref byte address,
                                            byte dmaxfre,
                                            byte dminfre);
        [DllImport("DL880.dll")]
        public static extern int SetBaudRate(ref byte address,
                                            byte baud);

        [DllImport("DL880.dll")]
        public static extern int InventorySingle_6B(ref byte address,
                                           ref byte ant,
                                           byte[] ID_6B);

        [DllImport("DL880.dll")]
        public static extern int ReadData_6B(ref byte Address,
								             byte[] ID_6B ,
								             byte  StartAddress,
								             byte Num,
								             byte[] Data,
								  	         ref int Errorcode);

        [DllImport("DL880.dll")]
        public static extern int WriteData_6B(ref byte Address,
                                            byte[] ID_6B,
                                            byte StartAddress,
                                            byte[] Writedata,
                                            byte Writedatalen,
                                            ref byte writtenbyte,
                                            ref int Errorcode);

         [DllImport("DL880.dll")]
         public static extern int WriteEPC_G2 (ref byte Address, 
                                               byte[] Password,
                                               byte[] WriteEPC,
                                               byte ENum, 
                                               ref int errorcode);
        [DllImport("DL880.dll")]
        public static extern int EASConfigure_G2(ref byte Address,    
                                                byte[] EPC,
                                                byte ENum,
                                                byte[] Password,
 	                                            byte EAS,
                                                byte MaskMem,
                                                byte[] MaskAdr,
                                                byte MaskLen,
                                                byte[] MaskData,
                                                ref int errorcode);
        [DllImport("DL880.dll")]
        public static extern int EASAlarm_G2(ref byte Address,
                                                   ref int errorcode);

        [DllImport("DL880.dll")]
        public static extern int GetTMP_G2(ref byte Address,
                                                byte[] EPC,
                                                byte ENum,
                                                byte WordPtr,
                                                byte WaitTime,
                                                byte[] Data,
                                                ref int errorcode);


    }
}
